
#define MAX_DEVICE_NAME  128


#if defined(_WIN95)    
    // Windows 95 Registry bases
    // Win95 requires 2 seperate sections - ...\Class\.. from driver data
    // and ...\Vxd\ for driver start info
#define DRIVER_REGISTRY_BASE\
        "SYSTEM\\CurrentControlSet\\Services\\Class\\WinRT"
#define MACHINE_REGISTRY_BASE\
        "\\Registry\\Machine\\System\\CurrentControlSet\\Services\\Class\\WinRT"
    // Individual device Vxd start-up section
#define VXD_REGISTRY_BASE\
        "SYSTEM\\CurrentControlSet\\Services\\VxD"
#define MACHINE_VXD_REGISTRY_BASE\
        "\\Registry\\Machine\\System\\CurrentControlSet\\Services\\VxD"
#else
       // NT Regsitry base
#define DRIVER_REGISTRY_BASE\
        "SYSTEM\\CurrentControlSet\\Services\\WinRT"
#define MACHINE_REGISTRY_BASE\
        "\\Registry\\Machine\\System\\CurrentControlSet\\Services\\WinRT"

#endif      // _WIN95

    // contains a Devices parameter and an indication if it is valid
typedef struct _DEVICE_ITEM
{
    DWORD   dwItemValue;                // For item's value
    BOOLEAN bItemEmpty;                 // For item-has-value status
} DEVICE_ITEM, *PDEVICE_ITEM;


    // Device data - see manual appendix for definition
    // of registry entries
typedef struct _DEVICE
{
    CHAR    szDeviceName[MAX_DEVICE_NAME];  // Name of this device
    CHAR    szVxdName[MAX_DEVICE_NAME]; // Name of this Vxd
    DWORD   dwDeviceNumber;             // Number of this device
    DEVICE_ITEM  PortAdrs;              // Section 0 Data
    DEVICE_ITEM  PortCnt;
    DEVICE_ITEM  MemAdrs;
    DEVICE_ITEM  MemCnt;
    DEVICE_ITEM  IntNum;
    DEVICE_ITEM  IntLevel;
    DEVICE_ITEM  IntShare;
    DEVICE_ITEM  IntMode;
    DEVICE_ITEM  BusNum;
    DEVICE_ITEM  BusType;
    DEVICE_ITEM  IoIncrem;
    DEVICE_ITEM  AllowConflict;
    DEVICE_ITEM  Disable;
    DEVICE_ITEM  PortAdrs1;             // Section 1 Data
    DEVICE_ITEM  PortCnt1;
    DEVICE_ITEM  MemAdrs1;
    DEVICE_ITEM  MemCnt1;
} DEVICE, *PDEVICE;

    // Driver data - see manual appendix for definition
    // of registry entries
typedef struct _DRIVER
{
    DWORD dwWinRTStart;
#if !defined(_WIN95)
    DWORD dwWinRTType;
    DWORD dwWinRTError;
#endif      // !_WIN95
} DRIVER, *PDRIVER;
