#include <stdlib.h>
#include <windows.h>
#include <winioctl.h>
#include "WinRTctl.h"
#include "Wrtreg.h"

/* macros */
#define MAX_SESSION_NUMBER 257
#define MAX_DEVICE_DIGITS 4
#define INVALID_DEVICE_NUMBER -1
#define MAX_WINRT_NAME 15
#define MAX_REGISTRY_NAME 256
#define PCI_BUS 5UL
#define EISA_BUS 2UL
#define _5ms 5UL
#define _50ms 50UL
#define _100ms 100UL
#define _500ms 500UL
#define _10000ms 10000UL

/* type definitions	*/
typedef unsigned char	uInt8;
typedef long				int32;
typedef unsigned long	uInt32;
typedef unsigned char	*CStr;
typedef double				*PDOUBLE;

/*	type declarations	*/
enum SCtrlFunc {Start_Session = 0, End_Session};
enum DCtrlFunc {Start_Driver = 0, Stop_Driver};
enum MemCommand {MapMemory = 0, UnmapMemory};

struct Table {
	int32	*Handle;         /* Handle to session's configuration in Registry.	*/
	int32	Device;          /* Number of session's configuration in Registry.	*/
   PVOID PhysMem1;        /* Pointer to session's primary memory resources.	*/
   PVOID PhysMem2;        /* Pointer to session's secondary memory resources.	*/
	int32 Occurrence;	  	  /* LabVIEW occurrence to be set on interrupt.  		*/
   HWND  WndHandle;       /* LabVIEW window to be notified of interrupt.		*/
	HANDLE IsrEvent;   	  /* Handle to session's ISR synchronization object.	*/
   BOOL TerminateIsr;	  /* Flag to signal IsrFunction thread's termination.	*/
};

/*	function prototypes	*/
DWORD DriverControl(enum DCtrlFunc eTask);
DWORD ConfigurePCIDevice(CStr szDeviceID,	uInt32 dwVendorId, uInt32 dwCardId);
DWORD DeviceToRegistry(PDEVICE pDevice);
DWORD UpdateRegValue(HKEY hKey, PCHAR pszName, PDEVICE_ITEM pItem);
DWORD DeleteRegDevice(CStr szDeviceID);
DWORD IsrFunction(HANDLE hSessionDevice);

/* obsolete functions	*/
int Search(int iKey, int List[], int nElements);
void Delay(DWORD dwMilliseconds);

